//STRIPPEDSOURCE//

package com.ms.wfc.html;

import com.ms.wfc.core.*;
import com.ms.wfc.html.om.*;
import com.ms.wfc.ui.*;
import com.ms.com.*;
import com.ms.win32.*;

/**
 * This class allows a com.ms.wfc.ui object to be succefully embedded
 * into an Internet Explorer web page.  Either contstuct the object
 * with a com.ms.wfc.ui.Control-derived object, or specify one using
 * <i>setControl</i>
 * 
 * @see #setControl
 * @security(checkClassLinking=on)
 */
public class DhComponentWrapper extends DhForm{
    
    
    private static final Object EVENT_COMPONENTREADY = new Object();
    
    
    private DhObjectFactory object;       
    private boolean objectAdded = false;
    
    
    private boolean ready = false;
    
    
    private Control controlObject;
    private boolean embed = false;
    
    
    private Control wfcSurface;
    
    /**
     * One-step default ctor
     */
    public DhComponentWrapper(){}
    
    /**
     * One-step ctor that allows specification of
     * the class to instantiate
     * @param c The Control to host
     */
    public DhComponentWrapper(Control c){}
    
    /**
     * One-step ctor that allows specification of
     * the class to instantiate
     * @param c The Control to host
     * @param embed <b>true</b> to embed top-level windows into IE, which is the default.
     */
    public DhComponentWrapper(Control c, boolean embed){}

    
    
    private DhComponentWrapper( Class c ){}
    
    private void addControl(Control c, boolean embed){}
    
    
    /**
     * Add a delegate to be invoked when the component has 
     * been successfully sited in IE.
     * @param h The Delegate to invoke
     */
    public void addOnComponentReady( EventHandler h ){}
  
    /**
     * Do clean up.
     */
    public void dispose(){}
   
    /**
     * Cleanup
     */
    public void finalize() throws Throwable{}
         
    /**
     * Returns the Control that is currently hosted in this object
     * @return The Control that is hosted.  May be <b>null</b>
     */
    public Control getControl(){}

    /**
     * Retrieves a reference to the WFC host surface that is hosted
     * directly in IE.  This method is for advanced users and should not
     * be called during normal usage of the DhComponentWrapper.
     * @return The com.ms.wfc.ui.Control host surface.
     */
    public Control getWFCSurface(){}
    
    
    private void onClick(Object s, Event e){}
 
    
    /**
     * This is called to fire the notification.
     * @param e The Event object
     */
    protected void onComponentReady( Event e ){}
    
    private void onFocus(Object s, Event e){}
    
    protected synchronized void onPeerAvailable(){}
    
    protected void onSetDocument(DhDocument doc){}
    
    private void onUnload(Object s, Event e){}
    
    /**
     * Remove an event handler to be fired when the host has
     * been successfully sited in IE
     * @param h The Delegate to invoke
     */
    public void removeOnComponentReady( EventHandler h ){}
    
    public void removeAll(){}
    
    int removeWashed(DhElement element) {}
    
    /**
     * Sets the control that is hosted in the object.
     * If a control is presently being hosted, it is 
     * first removed, then the specified control is added.
     * @param c The Control to host in IE
     */
    public void setControl( Control c ){}
    
    /**
     * Sets the control that is hosted in the object.
     * If a control is presently being hosted, it is 
     * first removed, then the specified control is added.
     * 
     * @param c The Control to host in IE
     * @param embed <b>true</b> to embed top level controls into IE.  Default is <b>true</b>.
     */    
    public void setControl(Control c, boolean embed){}
    
    /**
     * This class allows us to host in IE without the ActiveX safety dialog coming up.
     * @security(checkClassLinking=on)
     */
    public static class DhInnerSafeControl extends Control implements IObjectSafety{
        
        public static _Guid clsid = new _Guid("{FFD709F0-AF39-11D2-B854-0000F81E8872}");
        
        private static final int INTERFACESAFE_FOR_UNTRUSTED_CALLER = 0x00000001;	
        private static final int INTERFACESAFE_FOR_UNTRUSTED_DATA   = 0x00000002;	
        private static final int INTERFACE_USES_DISPEX	        = 0x00000004;	
        private static final int INTERFACE_USES_SECURITY_MANAGER	= 0x00000008;	
        
        static int createsAllowed = 0;
        
        public DhInnerSafeControl(){}
        
        public final void _GetInterfaceSafetyOptions(com.ms.com._Guid riid, int[] pdwSupportedOptions, int[] pdwEnabledOptions) {}
        
        public final void _SetInterfaceSafetyOptions(com.ms.com._Guid riid, int dwOptionSetMask, int dwEnabledOptions) {}
    }       
}





interface IObjectSafety extends IUnknown { 
    /** @com.method(vtoffset=0, addFlagsVtable=4)
     @com.parameters([in,type=PTR] riid, [out,size=1,type=ARRAY] pdwSupportedOptions, [out,size=1,type=ARRAY] pdwEnabledOptions) */
    public void _GetInterfaceSafetyOptions(com.ms.com._Guid riid, int[] pdwSupportedOptions, int[] pdwEnabledOptions);

    /** @com.method(vtoffset=1, addFlagsVtable=4)
     @com.parameters([in,type=PTR] riid, [in,type=U4] dwOptionSetMask, [in,type=U4] dwEnabledOptions) */
    public void _SetInterfaceSafetyOptions(com.ms.com._Guid riid, int dwOptionSetMask, int dwEnabledOptions);

    public static final com.ms.com._Guid iid = new com.ms.com._Guid((int)0xcb5bdc81, (short)0x93c1, (short)0x11cf, (byte)0x8f, (byte)0x20, (byte)0x0, (byte)0x80, (byte)0x5f, (byte)0x2c, (byte)0xd0, (byte)0x64);
}